module.exports = {
  extends: './eslintrc.js',
  parseOptions: { ecmaFeatures: { jsx: true } },
  globals: {
    __DEV__: false,
    XMLHttpRequest: false,
    FormData: false,
    fetch: false,
    requestAnimationFrame: false,
    cancelAnimationFrame: false,
    requestIdleCallback: false,
    cancelIdleCallback: false,
  },
  plugins: ['react'],
  rules: {
    'react/display-name': [0, { ignoreTranspilerName: false }],
    'react/jsx-boolean-value': [1, 'never'],
    'react/jsx-closing-bracket-location': [1, { nonEmpty: 'after-props', selfClosing: 'tag-aligned' }],
    'react/jsx-curly-spacing': [1, 'never'],
    'react/jsx-equals-spacing': [1, 'never'],
    'react/jsx-filename-extension': 0,
    'react/jsx-first-prop-new-line': [1, 'multiline'],
    'react/jsx-handler-names': 0,
    'react/jsx-indent': [1, 2],
    'react/jsx-indent-props': [1, 2],
    'react/jsx-key': 0,
    'react/jsx-max-props-per-line': 0,
    'react/jsx-no-bind': [1, { ignoreRefs: true }],
    'react/jsx-no-comment-textnodes': 0,
    'react/jsx-no-duplicate-props': 2,
    'react/jsx-no-literals': 0,
    'react/jsx-no-target-blank': 0,
    'react/jsx-no-undef': 2,
    'react/jsx-pascal-case': 0,
    'react/jsx-sort-props': 0,
    'react/jsx-space-before-closing': [1, 'always'],
    'react/jsx-tag-spacing': 1,
    'react/jsx-uses-react': 1,
    'react/jsx-uses-vars': 1,
    'react/jsx-wrap-multilines': [1, { declaration: false, assignment: false, return: true }],
    'react/forbid-component-props': 0,
    'react/forbid-prop-types': 0,
    'react/no-array-index-key': 0,
    'react/no-children-prop': 0,
    'react/no-danger': 0,
    'react/no-deprecated': 0,
    'react/no-did-mount-set-state': 1,
    'react/no-did-update-set-state': 1,
    'react/no-direct-mutation-state': 1,
    'react/no-find-dom-node': 0,
    'react/no-is-mounted': 0,
    'react/no-multi-comp': 0,
    'react/no-set-state': 0,
    'react/no-string-refs': 0,
    'react/no-unescaped-entities': 0,
    'react/no-unknown-property': 1,
    'react/no-unused-prop-types': 0,
    'react/prefer-es6-class': 0,
    'react/prefer-stateless-function': 0,
    'react/prop-types': 0,
    'react/react-in-jsx-scope': 2,
    'react/require-default-props': 0,
    'react/require-optimization': 0,
    'react/require-render-return': 1,
    'react/self-closing-comp': 1,
    'react/sort-comp': 0,
    'react/sort-prop-types': 0,
    'react/style-prop-object': 1,
  },
};
